<template>
  <div class="q-pa-md q-gutter-sm">
    <q-dialog v-model="toolbar">
      <q-card>
        <q-toolbar>
          <q-space />
          <q-btn color="purple" round dense icon="close" v-close-popup />
        </q-toolbar>
        <q-card-section> </q-card-section>
      </q-card>
    </q-dialog>
  </div>

  <q-dialog v-model="confirm" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="priority_high" color="red" text-color="white" />
        <span class="q-ml-sm"
          >Esta seguro de eliminar el id: {{ idelim }} ?</span
        >
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="Cancelar" color="red" v-close-popup />
        <q-btn
          flat
          label="Confirmar"
          color="primary"
          @click="eliminar(idelim)"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
  <div class="q-pa-md">
    <q-table
      title="Treats"
      :rows="allPedidos"
      :columns="columns"
      row-key="id"
      :filter="filter"
    >
      <template v-slot:top>
        <q-space />
        <q-input
          borderless
          dense
          debounce="300"
          color="primary"
          v-model="filter"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th auto-width />
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            {{ col.label }}
          </q-th>
        </q-tr>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td auto-width>
            <q-btn
              size="sm"
              color="accent"
              round
              dense
              @click="props.expand = !props.expand"
              :icon="props.expand ? 'visibility_off' : 'visibility'"
            />
          </q-td>
          <!-- id -->
          <q-td key="id" :props="props">
            {{ props.row.id }}
          </q-td>
          <!-- Estado  -->
          <q-td key="id" :props="props">
            {{ estados[props.row.state_id - 1].estado }}
            <q-popup-edit
              v-model="estados[props.row.state_id - 1].estado"
              v-slot="scope"
              title="estado"
              buttons
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  updatePedido(v.id, iv, props.key, 'state_id');
                }
              "
            >
              <q-select
                v-model="scope.value"
                :options="estados"
                option-value="id"
                option-label="estado"
                label="estado"
                behavior="menu"
                :rules="[
                  (val) => val !== null || 'Debe seleccionar una state_id',
                ]"
              />
            </q-popup-edit>
          </q-td>
          <!-- fecha  -->
          <q-td key="application_date" :props="props">
            {{ props.row.application_date }}
          </q-td>
          <!-- Hora  -->
          <q-td key="request_time" :props="props">
            {{ props.row.request_time }}
          </q-td>
          <!-- direccion envio  -->
          <q-td key="shipping_address" :props="props">
            {{ props.row.shipping_address }}
          </q-td>
          <!-- Total a pagar  -->
          <q-td key="total_pay" :props="props">
            {{ props.row.total_pay }}
          </q-td>
          <!-- Medio de pago -->
          <q-td key="payment_methods_id" :props="props">
            {{
              (qq = mediosPagos.find(
                (m) => m.id === props.row.payment_methods_id
              )).kind
            }}
          </q-td>
        </q-tr>
        <q-tr v-show="props.expand" :props="props">
          <q-td colspan="100%">
            <div class="text-left">
              <q-list style="width: 100%" class="rounded-borders">
                <div
                  class="flex column"
                  v-for="producto in props.row.products"
                  :key="producto.description"
                >
                  {{ producto.description }}:
                  {{ producto.orders_has_products.ordered_quantity }}
                  *
                  {{ producto.orders_has_products.unit_price }}
                  =
                  {{ producto.orders_has_products.line_price }}
                </div>
              </q-list>
            </div>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
import { api } from "boot/axios";
import { ref, onMounted } from "vue";
import { useQuasar, SessionStorage } from "quasar";

const columns = [
  {
    name: "id",
    required: true,
    label: "Nro Pedido",
    align: "left",
    field: (row) => row.id,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "state_id",
    align: "center",
    label: "Estado",
    // field: "state_id",
    field: (row) => row.state_id,
    format: (val) => `${val}`,
    //  sortable: true,
  },

  {
    name: "application_date",
    align: "center",
    label: "Fecha Pedido",
    field: "application_date",
    sortable: true,
  },
  {
    name: "request_time",
    align: "center",
    label: "Hora Pedido",
    field: "request_time",
    sortable: true,
  },
  {
    name: "shipping_address",
    align: "center",
    label: "Direccion de entrega",
    field: "shipping_address",
    sortable: true,
  },
  {
    name: "total_pay",
    align: "center",
    label: "Total a Pagar",
    field: "total_pay",
    sortable: true,
  },
  /*   {
    name: "users_id",
    align: "center",
    label: "User id",
    field: "users_id",
    sortable: true,
  }, */
  {
    name: "payment_methods_id",
    align: "center",
    label: "Medio de pago id",
    field: "payment_methods_id",
    sortable: true,
  },
];

export default {
  setup() {
    const $q = useQuasar();
    const token = SessionStorage.getItem("jwt");
    const estados = [
      {
        id: 1,
        estado: "Pendiente",
        // detalle: "cuando el usuario inicia su pedido.",
      },
      {
        id: 2,
        estado: "Confirmado",
        // detalle: "cuando el usuario cierra su pedido.",
      },
      {
        id: 3,
        estado: "Preparación",
        // detalle: "cuando el administrador comienza a preparar el pedido.",
      },
      {
        id: 4,
        estado: "Enviado",
        // detalle: "cuando el administrador envía el pedido.",
      },
      {
        id: 5,
        estado: "Cancelado",
        // detalle: "cuando el usuario cancela su pedido.",
      },
      {
        id: 6,
        estado: "Entregado",
        // detalle: "cuando el administrador entrega el pedido.",
      },
    ];
    let allPedidos = ref([]);
    function returnPedidos() {
      allPedidos.value.splice(0, allPedidos.value.length);
      api
        .get("pedidos/todos", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          // data.value = response.data.data;
          allPedidos.value = response.data.data;
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
        });
    }

    const mediosPagos = ref(null);
    async function cargarMediosPagos() {
      api
        .get("mediosPago", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          mediosPagos.value = response.data.data;
          // return JSON.stringify(response.data.data);
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
        });
    }

    onMounted(() => {
      cargarMediosPagos();
      returnPedidos();
    });
    return {
      filter: ref(""),
      updatePedido(value, initialValue, id) {
        api
          .put(`pedidos/${id}/${value}`, "", {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se actualizo al estado ${
                estados[value - 1].estado
              } correctamente`,
              icon: "mood",
            });
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
        returnPedidos();
      },
      save(value, initialValue, id, field) {
        const pedido = `{ "${field}": "${value}"  }`;
        api
          .put(`pedidos/${id}`, JSON.parse(pedido), {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se guardo el campo: ${field} con el nuevo valor ${value} correctamente`,
              icon: "mood",
            });
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      eliminar(id) {
        api
          .delete(`productos/${id}`, {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se elimino el usuario id: ${this.idelim.value} correctamente`,
              icon: "mood",
            });
            returnProducts();
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      columns,
      rows: ref(allPedidos),
      allPedidos,
      mediosPagos,
      estados,
      confirm: ref(false),
      // verProduct: ref(false),
      toolbar: ref(false),
      idelim: ref(0),

      // sendProduct: ref([]),
    };
  },
  components: {},
};
</script>
